SystemOrganization addCategory: #'ToolDad-Pharo14'!

TestCase subclass: #IDADFromToTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

IDADFromToTest subclass: #IDADFromBrowserToInspectorTest
	instanceVariableNames: 'browser inspector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADFromBrowserToInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 10:43'!
setUp

	super setUp.
	browser := Browser new.
	inspector := Inspector new.! !

!IDADFromBrowserToInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 10:48'!
testDraggedItemForIDAD

	"draggedItemForIDAD"
	| t |
	t := TransferMorph new.
	t passenger: 'apple' -> #pie.
	
	t dragTransferType: #messageList.
	self assert: t draggedItemForIDAD equals: #pie.
	
	t dragTransferType: #InspectorDAD.
	self assert: t draggedItemForIDAD equals: 'apple' -> #pie.! !

TestCase subclass: #IDADSingleTest
	instanceVariableNames: 'inspector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

IDADSingleTest subclass: #IDADForArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForArrayTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:22'!
objectToInspect

	^(14 to: 22) asArray.! !

!IDADForArrayTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/31/2008 18:57'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: '#(14 15 16 17 18 19 20 21 22)
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: 14. "first"
	self assert: (inspector draggedItemAtIndex: 4) equals: 15. "second"! !

!IDADForArrayTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:10'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| original |
	original := inspector object second.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object second equals: original.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object second equals: original.

	inspector dropItem: 123 atIndex: 3.
	self assert: inspector object second equals: original.
	
	inspector dropItem: 123 atIndex: 4.
	self deny: inspector object second = original.! !

!IDADForArrayTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/31/2008 18:55'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

IDADSingleTest subclass: #IDADForByteStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForByteStringTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:23'!
objectToInspect

	^'123' copy.! !

!IDADForByteStringTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:15'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: '''123''
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: 49. "$a"
	self assert: (inspector draggedItemAtIndex: 4) equals: 50. "$b"! !

!IDADForByteStringTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:18'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| original |
	original := inspector object last.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object last equals: original.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object last equals: original.
	
	inspector dropItem: 123 atIndex: 5.
	self deny: inspector object last = original.! !

!IDADForByteStringTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 16:22'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self deny: (inspector wantsDropFromInspector: nil) "nil not allowed".
	self assert: (inspector wantsDropFromInspector: $g) "characters are OK".
	self deny: (inspector wantsDropFromInspector: 'hi') "string not allowed".
	self deny: (inspector wantsDropFromInspector: 1000) "integer too big not allowed".	
	self assert: (inspector wantsDropFromInspector: 100) "0~255 OK".! !

IDADSingleTest subclass: #IDADForDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForDictionaryTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:23'!
objectToInspect

	^(Dictionary new at: 1 put: 'one'; at: 'two' put: 2; at: 3 put: 'three'; yourself).! !

!IDADForDictionaryTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:45'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''. "invalid index"
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: 'tally: 	3
array: 	{''two''->2 . 1->''one'' . nil . 3->''three'' . nil}
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: 3. "tally"
	self assert: (inspector draggedItemAtIndex: 4) equals: {'two'->2 . 1->'one' . nil . 3->'three' . nil}.  "array"! !

!IDADForDictionaryTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:49'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| original |
	original := inspector object at: 'two'.
	inspector dropItem: 123 atIndex: 1. "dropping on self"
	self assert: (inspector object at: 'two') equals: original.
	
	inspector dropItem: 123 atIndex: 2. "dropping on all inst vars"
	self assert: (inspector object at: 'two') equals: original.
	
	inspector dropItem: 123 atIndex: 5. "dropping on 'two' "
	self assert: (inspector object at: 'two') equals: 123.! !

!IDADForDictionaryTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:37'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

IDADSingleTest subclass: #IDADForObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForObjectTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:23'!
objectToInspect

	^Morph new.! !

!IDADForObjectTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/31/2008 18:52'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: 'bounds: 	0@0 corner: 50@40
owner: 	nil
submorphs: 	#()
fullBounds: 	nil
color: 	Color blue
extension: 	nil
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: (0@0 corner: 50@40). "bounds"
	self assert: (inspector draggedItemAtIndex: 4) equals: nil. "owner"! !

!IDADForObjectTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/31/2008 18:51'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| original |
	original := inspector object color.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object color equals: original.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object color equals: original.
	
	inspector dropItem: 123 atIndex: 7.
	self deny: inspector object color = original.! !

!IDADForObjectTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/31/2008 18:54'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

IDADSingleTest subclass: #IDADForOrderedCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForOrderedCollectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:23'!
objectToInspect

	^(OrderedCollection with: 'a string' with: #Smalltalk with: 100 with: Array new).! !

!IDADForOrderedCollectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:25'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: 'array: 	#(nil nil ''a string'' #Smalltalk 100 #() nil nil nil nil)
firstIndex: 	3
lastIndex: 	6
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: #(nil nil 'a string' #Smalltalk 100 #() nil nil nil nil). "array"
	self assert: (inspector draggedItemAtIndex: 4) equals: 3. "firstIndex"
	self assert: (inspector draggedItemAtIndex: 5) equals: 6. "lastIndex"
	self assert: (inspector draggedItemAtIndex: 8) equals: 100. "self at: 3"! !

!IDADForOrderedCollectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:42'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| original |
	original := inspector object last.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object last equals: original.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object last equals: original.
	
	inspector dropItem: 123 atIndex: 9.
	self deny: inspector object last = original.! !

!IDADForOrderedCollectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 01:20'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

IDADSingleTest subclass: #IDADForSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADForSetTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:24'!
objectToInspect

	^(Set with: 0 with: 1  with: 2 with: 0).! !

!IDADForSetTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:55'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: 'tally: 	3
array: 	#(0 1 2 nil nil)
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: 3. "tally"
	self assert: (inspector draggedItemAtIndex: 4) equals: #(0 1 2 nil nil). "array"
	self assert: (inspector draggedItemAtIndex: 5) equals: 0. "element"! !

!IDADForSetTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:57'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| originalSize |
	originalSize := inspector object size.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object size equals: originalSize.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object size equals: originalSize.
	
	inspector dropItem: 123 atIndex: 6.
	self assert: inspector object size equals: originalSize+1.! !

!IDADForSetTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 15:50'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

IDADSingleTest subclass: #IDADInspectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!IDADInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:24'!
objectToInspect

	^(Set with: 0 with: 1  with: 2 with: 0).! !

!IDADInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 16:32'!
testDraggedItemAtIndex

	"draggedItemAtIndex:"
	self assert: (inspector draggedItemAtIndex: 0) equals: ''.
	self assert: (inspector draggedItemAtIndex: 1) equals: inspector object. "self"
	self assert: (inspector draggedItemAtIndex: 2) equals: 'tally: 	3
array: 	#(0 1 2 nil nil)
'. "all inst vars"
	self assert: (inspector draggedItemAtIndex: 3) equals: 3. "tally"
	self assert: (inspector draggedItemAtIndex: 4) equals: #(0 1 2 nil nil). "array"
	self assert: (inspector draggedItemAtIndex: 5) equals: 0. "element"! !

!IDADInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 16:32'!
testDropItemAtIndex

	"dropItem:atIndex:"
	"See if the color instVar change"
	| originalSize |
	originalSize := inspector object size.
	inspector dropItem: 123 atIndex: 1.
	self assert: inspector object size equals: originalSize.
	
	inspector dropItem: 123 atIndex: 2.
	self assert: inspector object size equals: originalSize.
	
	inspector dropItem: 123 atIndex: 6.
	self assert: inspector object size equals: originalSize+1.! !

!IDADInspectorTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2009 16:32'!
testWantsDropFromInspector

	"wantsDropFromInspector:"
	self assert: (inspector wantsDropFromInspector: nil) "wants all object being dropped"! !

!IDADSingleTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:20'!
inspectorOf: anObject

	^(ToolSet inspectorClassOf: anObject) inspect: anObject! !

!IDADSingleTest methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2009 15:22'!
setUp

	super setUp.
	inspector := self inspectorOf: self objectToInspect! !

!PluggableListMorph methodsFor: '*tooldad-pharo14-events-processing' stamp: 'hjo 12/18/2008 12:16'!
handleMouseMove: anEvent
	"Reimplemented because we really want #mouseMove when a morph is dragged around"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	
	(anEvent hand hasSubmorphs and:[self dropEnabled]) ifTrue: [anEvent hand newMouseFocus: self].
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

PluggableListMorph subclass: #PluggableListMorphForIDADInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!PluggableListMorphForIDADInspector methodsFor: 'drag and drop' stamp: 'hjo 1/2/2009 10:36'!
acceptDroppingMorph: aMorph event: evt
	| item |
	dropItemSelector ifNil:[^self].
	item := aMorph draggedItemForIDAD.
	model perform: dropItemSelector with: item with: potentialDropRow.
	self resetPotentialDropRow.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
dragItemSelector
	^dragItemSelector! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
dropItemSelector
	^dropItemSelector! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableListMorphForIDADInspector methodsFor: 'drag and drop' stamp: 'hjo 1/2/2009 10:31'!
droppingItemFromPassenger: aTransferMorph

	aTransferMorph dragTransferType = #messageList
		ifTrue: [^aTransferMorph passenger value].
	aTransferMorph dragTransferType = #InspectorDAD
		ifTrue: [^aTransferMorph passenger].
	self error: 'Unexpected transfer type'! !

!PluggableListMorphForIDADInspector methodsFor: 'drag and drop' stamp: 'hjo 1/3/2009 11:48'!
startDrag: evt 
	| ddm draggedItem dragIndex |
	dragItemSelector ifNil:[^self].
	evt hand hasSubmorphs ifTrue: [^ self].
	[(self dragEnabled and: [model okToChange]) ifFalse: [^ self].
	dragIndex := self rowAtLocation: evt position.
	dragIndex = 0 ifTrue:[^self].
	draggedItem := model perform: dragItemSelector with: dragIndex.
	draggedItem ifNil:[^self].
	ddm := TransferMorph withPassenger: draggedItem from: self.
	ddm dragTransferType: #InspectorDAD.
	evt hand grabMorph: ddm]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableListMorphForIDADInspector methodsFor: 'accessing' stamp: 'hjo 1/1/2009 16:46'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableListMorphForIDADInspector methodsFor: 'drag and drop' stamp: 'hjo 1/2/2009 10:30'!
wantsDroppedMorph: aMorph event: anEvent
	
	(#(InspectorDAD messageList) includes: aMorph dragTransferType)
		ifFalse: [Transcript show: aMorph dragTransferType;cr. ^false]
		ifTrue: 
		[
			dropItemSelector ifNil:[^false].
			wantsDropSelector ifNil:[^true].
			^(model perform: wantsDropSelector with: aMorph passenger) == true
		]! !

!MorphicUIManager methodsFor: '*tooldad-pharo14' stamp: 'hjo 4/4/2012 10:32'!
openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel 
	"(Inspector openAsMorphOn: SystemOrganization withLabel: 'Test') openInWorld"
	| window inspector |
	inspector := inspectorClass inspect: anObject.
	window := (SystemWindow labelled: aLabel)
				model: inspector.
	window
		addMorph: ((PluggableListMorphForIDADInspector new doubleClickSelector: #inspectSelection;
				
				on: inspector
				list: #fieldList
				selected: #selectionIndex
				changeSelected: #toggleIndex:
				menu: #fieldListMenu:
				keystroke: #inspectorKey:from:) 
				autoDeselect: false;
				enableDragNDrop: true;
				dragItemSelector: #draggedItemAtIndex: ;
				dropItemSelector: #dropItem:atIndex: ;
				wantsDropSelector: #wantsDropFromInspector:)
				"For doubleClick to work best disable autoDeselect"
		frame: (0 @ 0 corner: inspectorClass horizontalDividerProportion @ inspectorClass verticalDividerProportion).
	window
		addMorph: (PluggableTextMorph
				on: inspector
				text: #contents
				accept: #accept:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
		frame: (inspectorClass horizontalDividerProportion @ 0 corner: 1 @ inspectorClass verticalDividerProportion).
	window
		addMorph: ((PluggableTextMorph
				on: inspector
				text: #trash
				accept: #trash:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:)
				askBeforeDiscardingEdits: false)
		frame: (0 @ inspectorClass verticalDividerProportion corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#fieldList ).
	window position: 16 @ 0.
	"Room for scroll bar."
	^ window
! !

!SetInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 16:29'!
arrayIndexForMyIndex: anInteger

	^ (self fieldList at: anInteger) asInteger! !

!SetInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 16:28'!
draggedItemAtIndex: anInteger

	anInteger = 0 ifTrue: [^ ''].
	anInteger = 1 ifTrue: [^ object].
	anInteger = 2 ifTrue: [^ object longPrintString].
	(anInteger - 2) <= object class instSize
		ifTrue: [^ object instVarAt: anInteger - 2].

	^ object array at: (self arrayIndexForMyIndex: anInteger)! !

!SetInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 16:00'!
dropItem: anObject atIndex: anInteger

	anInteger = 0 ifTrue: [^ self "drop on self"].
	anInteger = 1 ifTrue: [^ self "drop on all inst vars"].
	anInteger = 2 ifTrue: [^ self "drop on tally"].
	anInteger = 3 ifTrue: [^ self "drop on array"].
	^object add: anObject! !

!Inspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 16:09'!
draggedItemAtIndex: anInteger

	"The receiver has a list of variables of its inspected object.
	One of these is selected. Answer the value of the selected variable."
	| basicIndex |
	anInteger = 0 ifTrue: [^ ''].
	anInteger = 1 ifTrue: [^ object].
	anInteger = 2 ifTrue: [^ object longPrintStringLimitedTo: 20000].
	(anInteger - 2) <= object class instSize
		ifTrue: [^ object instVarAt: anInteger - 2].
	basicIndex := anInteger - 2 - object class instSize.
	(object basicSize <= (self i1 + self i2)  or: [basicIndex <= self i1])
		ifTrue: [^ object basicAt: basicIndex]
		ifFalse: [^ object basicAt: object basicSize - (self i1 + self i2) + basicIndex]! !

!Inspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 17:46'!
dropItem: anObject atIndex: anInteger
 
	"The receiver has a list of variables of its inspected object.
	One of these is selected. Answer the value of the selected variable."
	| basicIndex |
	anInteger = 0 ifTrue: [^ self "exit"].
	anInteger = 1 ifTrue: [^ self "exit"].
	anInteger = 2 ifTrue: [^ self "exit"].
	(anInteger - 2) <= object class instSize
		ifTrue: [^ object instVarAt: anInteger - 2 put: anObject ].
	basicIndex := anInteger - 2 - object class instSize.
	(object basicSize <= (self i1 + self i2)  or: [basicIndex <= self i1])
		ifTrue: [^ object basicAt: basicIndex put: anObject]
		ifFalse: [^ object basicAt: object basicSize - (self i1 + self i2) + basicIndex put: anObject]! !

!Inspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 16:06'!
wantsDropFromInspector: anObject

	"anObject is object being dragged."
	^object canReceiveDroppedObject: anObject! !

!TextMorphForEditView methodsFor: '*tooldad-pharo14' stamp: 'HwaJong 1/18/2013 18:27'!
transferIt
	editor transferIt! !

!DictionaryInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 15:42'!
draggedItemAtIndex: anInteger

	anInteger <= (self numberOfFixedFields) ifTrue: [^ super draggedItemAtIndex: anInteger ].
	^ object at: (keyArray at: anInteger - self numberOfFixedFields) ifAbsent:[nil]! !

!DictionaryInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 15:49'!
dropItem: anObject atIndex: anInteger

	anInteger <= (self numberOfFixedFields) ifTrue: [^ super dropItem: anObject atIndex: anInteger ].
	^ object at: (keyArray at: anInteger - self numberOfFixedFields) put: anObject! !

!SmalltalkEditor methodsFor: '*tooldad-pharo14' stamp: 'HwaJong 1/18/2013 18:26'!
transferIt

	| result |
	result := self evaluateSelection.
	(((TransferMorph withPassenger: result from: morph) 
		dragTransferType: #InspectorDAD)
		addMorph: result asMorph) openInHand
	! !

!PluggableTextMorph methodsFor: '*ToolDad-pharo14' stamp: 'HwaJong 1/18/2013 18:25'!
transferIt
	self handleEdit: [textMorph transferIt]! !

!Morph methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/4/2009 12:43'!
asDraggableMorph

	"Dont drag the object but a copy of it. Looks simular."
	| thumbnail |
	thumbnail _ Thumbnail new.
	thumbnail makeThumbnailFromForm: (self imageFormDepth: 32).
	^thumbnail! !

!Morph methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/2/2009 11:35'!
isAcceptedDroppingMorphEvent: aDropEvent inMorph: targetMorp by: aWorkspace 

	^aWorkspace acceptDroppingNonTransferMorph: self event: aDropEvent inMorph: targetMorp! !

!ByteString methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 16:20'!
canReceiveDroppedObject: anObject 

	anObject isCharacter ifTrue: [^true].
	(anObject isInteger and: [anObject between: 0 and: 255]) ifTrue: [^true].
	^false! !

!OrderedCollectionInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 17:52'!
draggedItemAtIndex: anInteger

	"The receiver has a list of variables of its inspected object."

	(anInteger - 2) <= object class instSize
		ifTrue: [^ super draggedItemAtIndex: anInteger].
	^ object at: (self objectIndexForMyIndex: anInteger)! !

!OrderedCollectionInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 17:51'!
dropItem: anObject atIndex: anInteger

	"The receiver has a list of variables of its inspected object."

	(anInteger - 2) <= object class instSize
		ifTrue: [^ super dropItem: anObject atIndex: anInteger].
	^ object at: (self objectIndexForMyIndex: anInteger) put: anObject! !

!OrderedCollectionInspector methodsFor: '*tooldad-pharo14' stamp: 'hjo 12/31/2008 16:17'!
objectIndexForMyIndex: anInteger
	"Answer the index of the inspectee's collection that the index refers to."

	| basicIndex |
	basicIndex := anInteger - 2 - object class instSize.
	^ (object size <= (self i1 + self i2)  or: [basicIndex <= self i1])
		ifTrue: [basicIndex]
		ifFalse: [object size - (self i1 + self i2) + basicIndex]! !

!Object methodsFor: '*tooldad-pharo14' stamp: 'hjo 1/1/2009 16:07'!
canReceiveDroppedObject: anObject 

	^true "very accepting kind"! !

Object subclass: #ToolDadMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolDad-Pharo14'!

!ToolDadMain classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/18/2013 18:32'!
smalltalkEditorMenuOn: aBuilder 
	"Specify the menu used when writing code. Try it with:
	(PragmaMenuBuilder 
		pragmaKeyword: 'smalltalkEditorMenu'
		model: nil) menu popUpInWorld
	"
	<smalltalkEditorMenu>
	| uitheme|
	uitheme := UITheme current.
	(aBuilder item: #'Transfer it (t)' translated) selector: #transferIt; help: nil; icon: uitheme  smallDoItIcon.! !
